
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ENode 1.0 - 框架的总体目标 / iVAN</title>

    <meta name="description" content="ENode 1.0 - 框架的总体目标 开源地址:https://github.com/tangxuehua/enode 本文想介绍一下enode框架要实现的目标以及部分实现分析思路剖析.总体来说enode框架是一个基于cqrs架构和消息驱动的应用开发框架.在说实现思路之前,我们先看一下enode框架希望实现的一些目标吧! 框架总体目标 高吞吐量(High Throughput).低延迟(Low Latency).高可用性(High Availability): 需要能充分利用CPU,即要允许方便配置需要使用的并行处理线程数,以提高单">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ENode 1.0 - 框架的总体目标</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>开源地址：<a href="https://github.com/tangxuehua/enode" rel="external nofollow noreferrer">https://github.com/tangxuehua/enode</a></p>
<p>本文想介绍一下enode框架要实现的目标以及部分实现分析思路剖析。总体来说enode框架是一个基于cqrs架构和消息驱动的应用开发框架。在说实现思路之前，我们先看一下enode框架希望实现的一些目标吧！</p>
<h1>框架总体目标</h1>
<ol>
<li>高吞吐量（High Throughput）、低延迟（Low Latency）、高可用性（High Availability）；</li>
<li>需要能充分利用CPU，即要允许方便配置需要使用的并行处理线程数，以提高单台机器的command处理能力；</li>
<li>支持command的同步和异步处理，同步处理时要允许客户端捕获异常，异步处理时要允许客户端设置回调函数；</li>
<li>应用编程模型要统一，框架api要简单、好用、一致、好理解；</li>
<li>能让开发人员只关注业务，不用关心数据哪里来，以及如何保存，也不用关心并发、重试、超时等技术相关的问题；</li>
<li>基于消息驱动的架构，那消息投递方面，要能做到：至少投递一次（即如果宕机了消息也不能丢）、且能做到最多投递一次，因为有时我们无法做到消息的等幂处理；</li>
<li>要足够可扩展，框架中每个组件都要允许用户自定义并替换掉，包括IOC容器；</li>
<li>因为是CQRS架构，那必须要确保单个聚合根的事件的持久化顺序与分发给查询端的顺序要完全一致，否则会出现严重的数据不一致的问题；</li>
</ol>
<h1>实现高吞吐量、低延迟、高可用的思路分析</h1>
<h2>关于性能的几个重要概念</h2>
<p>吞吐量是指系统每秒可以处理的请求数；延迟是指系统在处理一个请求时的延迟；一般来说，一个系统的性能受到这两个条件的约束，缺一不可。比如，我的系统可以顶得住一百万的并发，但是系统的延迟是2分钟以上，那么，这个一百万的负载毫无意义。系统延迟很短，但是吞吐量很低，同样没有意义。所以，一个好的系统的性能测试必然受到这两个条件的同时作用。有经验的朋友一定知道，这两个东西的一些关系：<strong>Throughput越大，Latency会越差。</strong>因为请求量过大，系统太繁忙，所以响应速度自然会低。<strong>Latency越好，能支持的Throughput就会越高。</strong>因为Latency短说明处理速度快，性能高，于是就可以处理更多的请求。所以，可以看出，最根本的，我们是要尽量缩短单次请求处理的时间。另外，可用性是指系统的平均无故障时间，系统的可用性越高，平均无故障时间越长。如果你的系统能保持一年365天都能7*24全天候正常运行，那说明你的系统可用性非常高。</p>
<h2>思路分析</h2>
<p>要实现高可用，要怎么办？简单的办法就是主备模式，即一份站点同时运行在主备服务器上，主服务器如果正常，那所有请求都由主服务器处理，当主服务器挂了，那自动切换到备服务器；这种方式能确保高可用；甚至我们还能设置多台备的服务器增加可用性；但是主备模式解决不了高吞吐量的问题，因为一台机器能处理的请求数总是有限的，那怎么办呢？我觉得就需要让我们的系统支持集群部署了，也就是说，不是只有一台机器在服务，而是同时有很多台机器在服务，这些同时服务的机器称为一个集群。而且为了能让集群中的服务器的负载能平衡，为了尽量避免某台服务器很忙，其他服务器很空的情况，我们还需要负载均衡技术。当然，真正的高可用同样意味着不能有单点故障问题，就是不能因为集群中的一个点挂了导致整个集群挂掉，所以我们要杜绝所有的数据都要经过某个点的设计；相反，要做到每个点都能横向扩展，web应用站点（enode框架支持）、内存缓存（memcached,redis都支持）、持久化（mongodb支持），都要能支持集群与负载均衡。好，整个系统所有层次都支持集群+负载均衡解决了高吞吐高可用无单点的问题，但并没有解决低延迟的问题，那怎么办呢？如何才能尽量快的处理一个用户请求呢？我觉得关键是三个方面：<strong>In Memory+尽量快的IO+无阻赛</strong>，也就是内存模式加很快的数据持久化加无阻塞的编程模型。</p>
<h2>In Memory</h2>
<p>in memory是什么意思呢？在enode框架中，主要的体现是，当我们要获取领域聚合根对象然后进行一些业务逻辑操作时，是从内存获取，而不是从数据库。这样的好处就是快。那这样做要面临的一些问题，如内存不够怎么办？用分布式缓存，如memcached, redis这样的成熟基于key-value模式的nosql产品。redis服务器挂了怎么办？没关系，我们可以让框架自动处理，即当发现内存缓存中不存在时，自动在从eventstore取，就是取出当前聚合根的所有事件，然后使用事件溯源（event sourcing，简称ES）的机制还原聚合根，然后尝试更新到缓存，然后返回给用户。这样就解决了缓存挂了的问题，当redis缓存服务器重启后，又能继续从缓存中取聚合根了；实际上，我们也要根据情况进行分布式集群部署redis服务器，这样一方面是为了能将数据sharding，另一方面能提高缓存的可用性，因为不会因为一台redis缓存服务器挂了导致整个系统所有的缓存数据都丢失了。另外，你可能会奇怪，redis缓存服务器里的数据哪里来呢？同样利用ES模式，因为我们在eventstore中存储了所有聚合根的所有的事件，所以我们就能在redis缓存服务器启动时，对所有需要放在缓存中的聚合根根据ES模式来得到。</p>
<h2>尽量快的持久化</h2>
<p>怎样才能尽量快的持久化呢？我们先分析下enode框架需要持久化的关键数据是什么，就是事件。因为enode框架是一个基于event sourcing架构模式的，我们不会存储对象的最终状态，而是存储对象每次发生的事件；并且，每次事件都是append的方式追加到eventstore。我们唯一需要确保的是eventstore中的事件表中的聚合根ID+事件版本号唯一即可；通过这个唯一索引，我们能检测同一个聚合根是否有并发冲突产生。除了这个唯一性索引的要求外，我们不需要事务的支持，因为我们每次总是只插入一条记录；好了，那这样的话，我们要选择传统的关系型数据库来持久化事件吗？显然不太合适，因为慢！更明智的选择是用性能更高的NoSQL DB。如MongoDB，MongoDB默认的持久化是先放入内存，然后每隔100毫秒写入日志，然后可能60秒写入一次磁盘。这样的特性使得我们可以非常快速的持久化事件，因为持久化事件实际上只是写到mongodb server的内存中而已。另外，当数据被写入到日志后，我们就可以认为数据已经被安全的持久化了，因为即使断电了，mongodb也能将数据从日志恢复。当然你的疑问是，那如果断电了，那理论上这100毫秒的数据不是就丢了，没关系，我们还可以同时把数据写入到多台mongodb server，也就是我们可以部署一个MongoDB server的集群，一般整个集群的所有机器都同时挂掉的可能性是很低的，所以我们可以认为这样的思路是可行的。当然，这里所说的一切要能实现，还需要很过重要的细节问题要考虑。本文主要是给出思路。我一直觉得解决问题的思路最重要，是吗？另外，mongodb是介于key-value结构的NoSQL产品和关系型DB之间，它是一个文档型数据库，最主要的是它也支持像数据库一样的关系查询、更新、删除等操作，再加上高性能以及支持集群分布式等特性；所以我觉得非常适合用来作为eventstore。</p>
<p>另外，还有一个问题很重要，那就是序列化。数据存储到mongodb时，要被序列化，而.net自带的二进制序列化类（BinaryFormatter）不是太快，所以会成为持久化的瓶颈，那怎么办呢？呵呵，当然也是去找一个更高效的二进制序列化类库了。目前为止，我找到的是一个开源的NetSerializer，测试下来发现是.net自带的10倍左右，这样的性能完全可以满足我们的要求了；再简单谈一下为什么NetSerializer能这么快呢？很简单，.net自带的BinaryFormatter每次都需要反射，而NetSerializer在程序启动时已经将所有要序列化的类型的元数据都一次性生成了，所以系列化或反序列化的时候就不用再做这一步耗时的操作，所以当然就快了。当然像google protocol buffer也性能非常高，也很成熟，对，总之序列化方面我们还有很多解决方案来优化。</p>
<h2>无阻塞的编程模型</h2>
<p>接下来我们来看看如何实现无阻塞。先想一下为什么要无阻赛？举个例子：比如电商网站通过信用卡来订购商品。一般的做法就很直接，就是先获取订单信息，通过银联的外部服务来验证信用卡信息是否有效（这意味着信用卡号如果有问题，根本就不会生成订单），然后生成订单信息入库，这两步放在一个操作里。这样做的问题是，由于信用卡验证服务是一个外部服务，因此操作往往会被阻塞较长的一段时间。这样就导致整个系统无法高效的运行。</p>
<p>无阻赛的方式是：把整个操作分为两个，第一个操作是获取用户填写的订单。这个操作的结果是产生一个“信用卡验证请求”的事件。第二个操作是当它接受一个“信用卡验证成功响应”的事件，生成订单入库。我们的系统在完成第一个操作之后会接下来执行另外其他的事件，也就是不会依赖于信用卡验证的结果了，直到“信用卡验证成功响应”事件产生了，我们的系统才会继续处理后续的创建订单的事情。</p>
<p>可以看出，这样的设计实际上就是一种事件驱动（event-driven）的思想。基于这样的思想，我们的系统一直在不停的运转，不会因为和外部系统的交互而要同步等待外部系统的处理结果。同样，对于一个用户操作如果涉及多个聚合根的修改的情况，也是采用这样的事件驱动的思想，采用我常提到的saga的思想。我们不会在一个command中把所有事情都做完，而是会通过command+event不断串联的无阻塞的方式来实现整个过程。这一点在我之前的<a href="http://www.cnblogs.com/netfocus/p/3149156.html" rel="external nofollow noreferrer">博文</a>中应该已经做了比较详细讨论了。</p>
<p>目前只能想到这么多分析思路吧，希望对大家有帮助。为了篇幅不要太长的原因，框架的其他一些目标的分析思路只能在后续的文章中慢慢讨论了。希望我能坚持下去。我个人能思考到的问题毕竟有限，希望大家看了后能多多提一些问题，然后大家讨论解决，这样才能让框架不断完善起来。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 06:04:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ENode 1.0 - 框架的总体目标的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodYqXM.html" rel="bookmark">ENode 1&period;0 - 框架的物理部署思路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开源地址:https://github.com/tangxuehua/enode 上一篇文章,介绍了enode框架的总体目标,以及如何实现高吞吐.低延迟.高可用.无单点问题的实现思路.本篇文章,我们再分析一下其他一些需要考虑的问题.我发现写文章挺累的,费时费脑经,但我会坚持下去.本文主要分析一下enode框架的物理部署: 物理部署思路:集群的web站点+分布式缓存和存储 集群的概念:多台机器做相同的业务,对外如一台机器在做事情一样,集群中任意一台机器挂了没有影响,因为其他机器还在工作:集群的机器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1RBkap.html" rel="bookmark">enode框架入门：框架的总体目标</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文想介绍一下enode框架要实现的目标以及部分实现分析思路剖析.总体来说enode框架是一个基于cqrs 架构和消息驱动的应用开发框架.在说实现思路之前,我们先看一下enode框架希望实现的一些目标吧! 框架总体目标 高吞吐量(High Throughput).低延迟(Low Latency).高可用性(High Availability): 需要能充分利用CPU,即要允许方便配置需要使用的并行处理线程数,以提高单台机器的command处理能力 : 支持command的同步和异步处理,同步处理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YxgoM.html" rel="bookmark">ENode 2&period;0 - 第一个真实案例剖析-一个简易论坛（Forum）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 经过不断的坚持和努力,ENode 2.0的第一个真实案例终于出来了.这个案例是一个简易的论坛,开发这个论坛的初衷是为了验证用ENode框架来开发一个真实项目的可行性.目前这个论坛在UI上是使用了最终一致性,也就是说当我们发帖或回帖后不会立马显示你的帖子或回复.当我们下一次刷新页面时,会显示出来.这点貌似很多人向我反馈不太习惯,接受不了,呵呵.我之所以这样做也是想看看最终一致性大家的接受程度如何,看来UI层面上的最终一致性,大部分人接受不了.回头我改进下效果,改为立即可以看到帖子或回复吧!另			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8wJab.html" rel="bookmark">ENode 2&period;0 - 整体架构介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 今天是个开心的日子,又是周末,可以轻轻松松的写写文章了.去年,我写了ENode 1.0版本,那时我也写了一个分析系列.经过了大半年的时间,我对第一个版本做了很多架构上的改进,最重要的就是让ENode实现了分布式,通过新增一个分布式消息队列EQueue来实现.之所以要设计一个分布式的消息队列是因为在enode 1.0版本中,某个特定的消息队列只能被某个特定的消费者消费.这样就会导致一个问题,就是如果这个消费者挂了,那这个消费者对应的消息队列就不能自动被其他消费者消费了.这个问题会直接导致系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZgQJb.html" rel="bookmark">ENode 1&period;0 - 整体架构介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 今天是个开心的日子,又是周末,可以安心轻松的写写文章了.经过了大概3年的DDD理论积累,以及去年年初的第一个版本的event sourcing框架的开发以及项目实践经验,再通过今年上半年利用业余时间的设计与开发,我的enode框架终于可以和大家见面了. 自从Eric Evan提出DDD领域驱动设计以来已经过了很多年了,现在已经有很多人在学习或实践DDD.但是我发现目前能够支持DDD开发的框架还不多,至少在国内还不多.据我所知道的java和.net平台,国外比较有名的有:基于java平台的是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOJLxp.html" rel="bookmark">jmetal 平台-在vc6&period;0 下jmetal 多目标平台 使用问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在vc6.0 下jmetal 多目标平台 使用问题 怎么使用jmetal 多目标平台呢?把它的各个包都放在VC6.0的哪里啊? 解决方案 http://tieba.baidu.com/p/1712883826			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balNlqz.html" rel="bookmark">&period;NET2&period;0框架中的AbstractFactory模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我这里只是从别的角度阐述一下AbstractFactory在这种应用场景下的发展,内容不多,希望大家见谅. 1. DbService 是我看到的第一个使用抽象工厂模式设计的数据库链接类.其实在几年前网上就有人写了这个东西,代码不多,但应用的背景和设计思路与永红(http://www.cnblogs.com/Yahong111/archive/2007/07/18/822946.html) 的思路非常相似.大家可以去网上搜一搜就知道了. 2. 微软也采用了这种模式在他们的NET2.0框架中.我甚至			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6V90b.html" rel="bookmark">C&num; vs2010 4&period;0框架，编译生成成功，但是bin文件下面生成不了引用的dll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C# vs2010 4.0框架,编译生成成功,但是bin文件下面生成不了引用的dll C# vs2010 4.0框架,编译生成成功,但是bin文件下面生成不了引用的dll 解决方案 右键项目 属性 查看你编译文件存放的路径 Properity--Build--Output path: 解决方案二: 右键查看解决方案在哪个目录,然后查看BIN文件下有没有dll. 或者或者点击方案右上角显示全部文件然后再看看bin下面有没有dll			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQNdEp.html" rel="bookmark">在xp系统里面，有&period;NET framework 3&period;5和 &period;NET framework 2&period;0框架，怎么让系统默认3&period;5框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在xp系统里面,我安装一个ERP应用程序,但是程序每次调用的都是默认的调用.NETframework2.0框架,我下载的.NETframework3.5框架没有调用就出现报错我拍是程序问题,就把程序拷贝到别的电脑上应用程序都是好的可以正常使用这怎么解决 解决方案 解决方案二:B/S架构的ERP,需要在IIS中配置默认的应用程序服务框架,配置默认为4.0,就可以了.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgwVBM.html" rel="bookmark" class="title">代码 还原 不执行-程序加密需要替换回车符，但解密还原后，遇到不执行的问题，怎么处理？</a>
					<div>
						问题描述 程序加密需要替换回车符,但解密还原后,遇到不执行的问题,怎么处理? &lt;%dd=5555bb=6666response.Write(dd&amp;bb)%&gt; 但换个方式就不执行.测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkVedM.html" rel="bookmark" class="title">基于PHP的超炫酷HTML5交互式图表</a>
					<div>
						用PHP实现专业级的基于Web的图表,而无需深入的HTML5和JavaScript知识. 介绍 最近,我需要从一组PHP数据组快速创建图表.要求图表必须是交互式的,用户友好的,也可下载的.在评估了一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEg6Lp.html" rel="bookmark" class="title">ASP验证带小数点数字格式的函数</a>
					<div>
						ASP验证带小数点数字格式的函数,数字范围是922337203685477 ~ -922337203685477 ,非常实用. ASP验证带小数点数字格式的函数,数字范围是92233720368547 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV97Yp.html" rel="bookmark" class="title">在VBScript中使用类（四）</a>
					<div>
						vbscript|vbscript 现在的代码离我们想要的还是有些不太实用,我们将在其他页使用类TVProgram,因此最好将其独立定义,以便所有也面都可以调用.创建一个ASP页面,并命名为TVPro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK5aOp.html" rel="bookmark" class="title">如何从Internet上有效而稳定地下载文件</a>
					<div>
						本文配套源码 如何从Internet上有效而稳定地下载文件,这是很多网络应用程序要考虑的重要问题,本文提供的代码段针对这个问题进行了初步的探索.希望能够抛砖引玉,对各位编程人员有所帮助. UINT I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91R2gM.html" rel="bookmark" class="title">Java开发2&period;0&colon; 使用Amazon SimpleDB实现云存储，第2部分</a>
					<div>
						Java开发2.0: 使用Amazon SimpleDB实现云存储,第2部分:使用SimpleJPA实现简单对象持久化 使用诸如 Grails 的关系框架对几乎所有类型的应用进行域对象建模是很容易的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AvL6p.html" rel="bookmark" class="title">PPTX格式文件怎么打开？三种方法教你如何打开PPTX文件</a>
					<div>
						同事把制作好的PPT幻灯片发给小熊,谁知道发过去小熊怎么也打不开,这是出了什么情况,一直用得挺好的,而且打开之前用过的幻灯片都没什么问题,为什么偏偏就同事发给小熊的这个幻灯片打不开呢?仔细一瞅原来同事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr54Zp.html" rel="bookmark" class="title">Excel如何绘制折线图？</a>
					<div>
						  1.选中需要绘制折线图的数据. 2.接着点击工具栏的&quot;插入&quot;→&quot;折线图&quot;,我们就可以根据自己的需求插入折线图类型啦. 3.插入后我们可以对折线图位置大小以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBOALz.html" rel="bookmark" class="title">Win7系统修改TXT文本文档后不能保存该如何解决</a>
					<div>
						  故障原因:是因为软件修改或者不小心点击了TXT的只读选项,只要设置为TXT文本文档去掉只读选项就可以正常使用了. 解决步骤: 1.文档编辑好了之后,我们右键点击-属性; 2.打开属性后,去掉&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaXO0z.html" rel="bookmark" class="title">win7无法显示Aero酷炫特效怎么办？</a>
					<div>
						  在win7家庭高级版.win7专业版或win7旗舰版这三个版本中都具备Aero特效.Aero界面结合轻薄透明的窗口外观与强大的图形高级功能,给用户带去与众不同的视觉特效,因此也得到了用户的广泛喜爱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG0PDb.html" rel="bookmark" class="title">深度 &vert; 黑客 Only&lowbar;Guest 讲述：如何优雅地手刃骗子？</a>
					<div>
						    他是誓与 AV 争宅男的 PKAV 团队掌门人: 他是每次演讲前必喝两口&quot;黑客啤酒&quot;的黑客: 他曾经黑掉美食城充值卡,免费享用&quot;大餐&quot;: 他曾经定位全成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjGXKb.html" rel="bookmark" class="title">114期：阿里云成为MariaDB基金会白金会员，手淘开源安卓客户端容器化框架Atlas！</a>
					<div>
						本期头条   • 阿里云成为MariaDB基金会白金会员:全球唯一入选云计算公司 • 大规模团队移动开发利器:手淘安卓客户端容器化框架Atlas正式开源 • [资料合集]Spark&amp;Hadoo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8BEGb.html" rel="bookmark" class="title">Docker  Registry 私有仓库搭建详细步骤&lowbar;docker</a>
					<div>
						Docker  Registry 私有仓库搭建 官方已经提供了很多版本的 Linux 镜像,直接从官方仓库(Public Repositories)下载就可以了.如果考虑到安全性和速度,我们可能会想在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEe0xz.html" rel="bookmark" class="title">解密-a2bc3d1转换成aabcbcbcd</a>
					<div>
						问题描述 a2bc3d1转换成aabcbcbcd 为什么代码中提取循环次数的多循环了??? import java.util.Scanner; /* 请完成右侧函数,该函数功能是解密一个给定字符串,解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEwr1z.html" rel="bookmark" class="title">insert into向access插入数据时，字段名（也就是列的名字）之间有空格，去掉空格，就可以</a>
					<div>
						问题描述 insert into向access插入数据时,字段名(也就是列的名字)之间有空格,去掉空格,就可以 insert into test(Image Name) values ('123342 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKRwdb.html" rel="bookmark" class="title">Android 实时视频采集&mdash;Cameara预览采集</a>
					<div>
						http://www.cnblogs.com/skyseraph/archive/2012/03/26/2418665.html 1 概述 通过Android Camera拍摄预览中设置setPrev ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AKk4z.html" rel="bookmark" class="title">关于c&plus;&plus;的一些问题&hellip;&hellip;大一新生刚接触</a>
					<div>
						问题描述 关于c++的一些问题--大一新生刚接触 1 定义一个类之后去创建一个它的对象,类的定义里没有构造函数,然后输出对象的成员,是乱码 乱码这个值是谁给的? 解决方案 系统分配了内存,这块内存原来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD23dz.html" rel="bookmark" class="title">火狐发Firefox 18&period;0 beta 2版本</a>
					<div>
						Firefox(火狐浏览器) 18.0 beta 2版本如期出现在官方FTP中,各位感兴趣的网友可以下载更新. Firefox 18的主要改进之处有: 改进标签页切换性能 支持苹果Retina视网膜屏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY58qQM.html" rel="bookmark" class="title">中国已经拥有5&period;91亿网民和4&period;64亿手机网民</a>
					<div>
						从1997年IBM在ChinaByte上刊登第一条商业性互联网广告至今,中国互联网广告已经走过16年,互联网已成为仅次于电视的广告主投放最大的媒体.据艾瑞咨询统计,2013年中国互联网广告或将突破千亿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zOJwkkp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4VXUxQ3RuRlJoNXZMZHlNRnJNbUZXaWMzc09UdDFyNFJoZGxGYURpYUhob01FUmlhTFRwMUN1YTM0VlZEQlJIOXRPYkZ0RFRic2RHY1FRZy8w.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zOJwkkp.html" rel="bookmark" class="title">陈凯：用数据解读爸爸去哪儿第二季</a>
					<div>
						这个时代学习能力是最重要的能力,而能够在周末的时间进行学习的人就更有竞争力.同时选择大数据这一方向来学习的人则是当今大数据时代最具有竞争力的人. 今天之所以选择用大数据解读爸爸去哪儿第二季这个话题是因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKl3Ap.html" rel="bookmark" class="title">杀毒软件Avast被曝0day漏洞&comma;可执行恶意代码</a>
					<div>
						Google安全专家Tavis Ormandy,发现一个Avast杀毒软件的0day漏洞,该漏洞可能导致攻击者侵入用户电脑,并在用户电脑上执行恶意代码. Tavis Ormandy近期在Avast杀毒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwQ06M.html" rel="bookmark" class="title">赵国栋：大数据时代经济发展转型之道</a>
					<div>
						文章讲的是赵国栋:大数据时代经济发展转型之道,2015年7月19日,以&quot;开源大数据技术的生态与应用&quot;为主题的&quot;第四届中国大数据应用论坛&quot;在北京大学隆重举办.本次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqjvvb.html" rel="bookmark" class="title">求一本书关于c&num; Windows 窗体应用程序 Windows Forms</a>
					<div>
						问题描述 求一本书关于c# Windows 窗体应用程序 Windows Forms 求一本书关于c# Windows 窗体应用程序 Windows Forms类似于下面这本书 解决方案 直接WPF吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8Lrjb.html" rel="bookmark" class="title">Android实现图片左右滑动效果&lowbar;Android</a>
					<div>
						关于滑动效果,在Android中用得比较多,本示例实现的滑动效果是使用ViewFlipper来实现的,当然也可以使用其它的View来实现.接下来就让我们开始实现这种效果. 接下来我们看一下程序结构图: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKo6yM.html" rel="bookmark" class="title">如何快速增加网站外链</a>
					<div>
						一 软文 软文是广为人知的增加外链的方法,包括像a5.chinaz这样的网站,都是很好的软文发布平台.我在做大家乐成都跑腿公司和念奴娇成都鲜花时,都有用到这个方法,效果相当显著.在大概7家软文网站发布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJO4e2b.html" rel="bookmark" class="title">百度搜索SEO偏重元素的比例和详解</a>
					<div>
						T language=javascript src=&quot;/plus/ad_js.php?aid=6&quot;&gt; 按100分算标题: 100外部链接:90域名: 80H1 H2 字号标题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z75R75M.html" rel="bookmark" class="title">PHP mysql与mysqli事务使用说明 分享&lowbar;php技巧</a>
					<div>
						mysqli封装了诸如事务等一些高级操作,同时封装了DB操作过程中的很多可用的方法. 应用比较多的地方是 mysqli的事务. 比如下面的示例: 复制代码 代码如下: $mysqli = new my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPOlkDM.html" rel="bookmark" class="title">桑迪飓风未对美国互联网服务造成严重影响</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 腾讯科技讯(童云)北京时间10月31日消息,虽然一些知名网站的服务中断,造成的&quot;涟漪效应&quot;偶尔导致全美范围的通信速度减缓,但互联网服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvql65b.html" rel="bookmark" class="title">久游剩空壳副总吴军及多位中高层离职</a>
					<div>
						久游副总裁吴军 网易科技讯 3月14日晚间消息,经历数番人事地震的久游又有最新动态:包括副总裁.新闻发言人吴军在内的多位中高层离职,久游&quot;维稳&quot;最后一道防线崩溃.另外,媒体部被整体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNOX1yp.html" rel="bookmark" class="title">遭遇过网络&OpenCurlyDoubleQuote;钓鱼&rdquo;的网民不在少数</a>
					<div>
						易观国际此前发布的一项调研报告显示,目前,国内网上支付用户面临的主要安全问题中,木马钓鱼导致损失的比例达到24%,仅次于账户或密码被盗33.9%的比例,且部分用户账户密码被盗也是因为木马钓鱼等原因造成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
